#include <QApplication>
#include <QHBoxLayout>
#include <QSlider>
#include <QSpinBox>

int main(int argc, char *argv[])
{
    //Je crée une application appelée "app"
    QApplication app(argc, argv);
    //Je crée un objet graphique appelé "window"; comme il n'a pas de parent, c'est forcément une fenêtre
    QWidget *maFenetre = new QWidget;
    //Je lui donne un titre (dans la barre de titre); remarque : je décale dans mon code l'opération par rapport à la création, je trouve plus clair...
    //Le code QString::fromUtf8(" permet de gérer les caractères spéciaux en cas ponctuel
        maFenetre->setWindowTitle(QString::fromUtf8("Mon âge"));

    //Je crée deux objets graphiques : un de type spinBox et un autre de type curseur (je précise horizontal, parce que par défaut c'est vertical)


    /*
    Pour m'entraîner j'utilise deux méthodes :
            pour le spinBox je crée l'objet immédiatement; donc les fonctions s'appellent avec un POINT; par contre comme "connect" et "addWidget" attendent une adresse, je suis obligé d'écrire "&" devant le nom
            pour le curseur je déclare un pointeur (un lien vers une adresse mémoire); les fonctions s'appellent alors avec une FLECHE, mais je peux utiliser le nom directement dans "connect" et "addWidget"
    */

    QSpinBox maValeur;// = new QSpinBox;
    QSlider *monCurseur = new QSlider(Qt::Horizontal);
    //Je leur donne un intervale de valeurs possibles
          // maValeur->setRange(0,130);
           maValeur.setRange(0,130);
           monCurseur->setRange(0,130);

    //Je crée une connexion entre les deux : si la valeur de ma spinBox change, donner la même au curseur
    QObject::connect(&maValeur, SIGNAL(valueChanged(int)), monCurseur, SLOT (setValue(int)));
    //et inversement
    QObject::connect(monCurseur, SIGNAL(valueChanged(int)), &maValeur, SLOT (setValue(int)));
    //Attention : la fonction connect concerne des pointeurs

    //Je donne une valeur de départ à ma spinBox
           maValeur.setValue(43);

    //Je crée une boite horizontale, pour y placer des objets les uns à côté des autres
    QHBoxLayout *maBoite = new QHBoxLayout;
    //J'y mets ma spinBox et mon curseur
            maBoite->addWidget(&maValeur);
            maBoite->addWidget(monCurseur);
    //Je mets ma boite dans ma fenetre
            maFenetre->setLayout(maBoite);
    //Ma fenetre est finie, je peux l'afficher
    maFenetre->show();
    //Je peux lancer mon application
    return app.exec();
}
